// ESP8266 Static page WEB server to control Mbed

#include "mbed.h"
#include "JPEGCamera.h"
#include "xbee.h"
#include "ESP8266Interface.h"
#include "TCPSocketConnection.h"
#include "SDFileSystem.h"
 
SDFileSystem sd(p5, p6, p7, p8, "sd"); // the pinout on the mbed Cool Components workshop board
//#include "rtos.h"

//Print temperature from TMP36 analog temperature sensor
///////////////////////////////////////////////////////////////////////////////
//Setup a new class for TMP36 sensor
class TMP36
{
public:
TMP36(PinName pin);
TMP36();
operator float ();
float read();
private:
//class sets up the AnalogIn pin
AnalogIn _pin;
};

TMP36::TMP36(PinName pin) : _pin(pin)
{
// _pin(pin) means pass pin to the AnalogIn constructor
}

float TMP36::read()
{
//convert sensor reading to temperature in degrees C
return ((_pin.read()*3.3)-0.500)*100.0;
}
//overload of float conversion (avoids needing to type .read() in equations)
TMP36::operator float ()
{
//convert sensor reading to temperature in degrees C
return ((_pin.read()*3.3)-0.500)*100.0;
}
///////////////////////////////////////////////////////////////////////////////





Serial pc(USBTX, USBRX);
//Serial esp(p28, p27); // tx, rx
LocalFileSystem local("local"); //save images on mbed

// Standard Mbed LED definitions
DigitalOut  led1(LED1);
DigitalOut  led2(LED2);
DigitalOut  led3(LED3);
DigitalOut  led4(LED4);

// some test values to show on web page
AnalogIn   Ain1(p18);
AnalogIn   Ain2(p19);

/*
char ssid[32] = "hsd";     // enter WiFi router ssid inside the quotes
char pwd [32] = "austin123"; // enter WiFi router password inside the quotes
*/
float temperature, AdcIn, Ht;
float R1=100000, R2=10000; // resistor values to give a 10:1 reduction of measured AnalogIn voltage
char Vcc[10];
char Temp[10];

// things for sending/receiving data over serial
volatile int tx_in=0;
volatile int tx_out=0;
volatile int rx_in=0;
volatile int rx_out=0;
const int buffer_size = 4095;
char tx_buffer[buffer_size+1];
char rx_buffer[buffer_size+1];
void Tx_interrupt();
void Rx_interrupt();
void send_line();
void read_line();
void alarmPhoto(int);

int DataRX;
int update;
int count;
char cmdbuff[1024];
char replybuff[4096];
char webdata[4096]; // This may need to be bigger depending on WEB browser used
char webbuff[4096];     // Currently using 1986 characters, Increase this if more web page data added
char timebuf[30];
void SendCMD(),getreply(),ReadWebData(),startserver();
void gettime(),setRTC(),getTemperature();
char rx_line[1024];
int port        =80;  // set server port
int SERVtimeout =5;    // set server timeout in seconds in case link breaks.
struct tm t;
// manual set RTC values
int minute      =00;    // 0-59
int hour        =12;    // 2-23
int dayofmonth  =26;    // 1-31
int month       =8;     // 1-12
int year        =15;    // last 2 digits

PwmOut Alarm(p21);
JPEGCamera camera(p13, p14); //Camera
TMP36 myTMP36(p15);
DigitalOut P16(p16);
DigitalOut P17(p17);
DigitalOut P19(p19);
DigitalOut P20(p20);
float tempC;
xbee xbee2(p9,p10,p11);
char read_data[202];
Serial esp(p28, p27); // tx, rx
void Email();
//ESP8266Interface esp1(p28, p27, p26, 9600, 3000);
//EthernetInterface eth;

////////
//tempC = myTMP36;
///printf(" T=%5.2F C \n\r", tempC);//for testing
//if(tempC>45) {
//add code
//}
///////

int main()
{
    camera.setPictureSize(JPEGCamera::SIZE320x240);
    pc.baud(9600);
    ////////////////////////////////xbee2.RecieveData(read_data,0); //ADD THIS BACK!!!
//    led3 = 1;
//    
//    ///////////Emailing the user
//    Email();
    esp.baud(9600);
    led1=1,led2=0,led3=0, led4=0;
    // Setup a serial interrupt function to receive data
    esp.attach(&Rx_interrupt, Serial::RxIrq);
    // Setup a serial interrupt function to transmit data
    esp.attach(&Tx_interrupt, Serial::TxIrq);
    Alarm.period(1.0/100);
    if (time(NULL) < 1420070400) {
        setRTC();
    }
    startserver();
    DataRX=0;
    count=0;
    xbee2.RecieveData(read_data,0);
    led3 = 1;
    Alarm = 0.5;
    //Take photo
    alarmPhoto(5); //will be saved as PICT005.jpg
    //FILE *fp = fopen("/local/pict005.jpg", "w");  // Open "out.txt" on the local file system for writing
//    if (fp != NULL) {
//        pc.printf("File opens\n");
//    }
//    mkdir("/sd/mydir", 0777);
//    FILE *fp1 = fopen("/sd/mydir/sdtest.jpg", "w");
//    //fprintf(fp1, fp);
//    fclose(fp1);
    
    // email the user
    // Can turn-off the alarm
    
//    
    ///////////Emailing the user
    //Email();
//    ESP8266Interface esp1(p28, p27, p26, 9600, 3000);
//    esp1.init();
//    esp1.connect("ssid", "password");
//    printf("IP Address is %s\n", esp1.getIPAddress());
//    TCPSocketConnection sock;
//    //delete esp1;
//
//
//    sock.connect("blahblahmbed.comlu.com", 80); //http://blahblahmbed.comlu.com/ "mbed.org"
//
//    char http_cmd[] = "GET http://blahblahmbed.comlu.com/index.php HTTP/1.0\n\n"; // /media/uploads/mbed_official/hello.txt
//    sock.send_all(http_cmd, sizeof(http_cmd)-1);
//    char buffer[300];
//    int ret;
//    while (true) {
//        ret = sock.receive(buffer, sizeof(buffer)-1);
//        if (ret <= 0) break;
//        buffer[ret] = '\0';
//        printf("Received %d chars from server:\n%s\n", ret, buffer);
//    }
//    sock.close();
//    esp1.disconnect();
//    //////////
    //if (time(NULL) < 1420070400) {
//        setRTC();
//    }
//    startserver();
    //eth.init(); //Use DHCP
    //eth.connect();
    //printf("IP Address is %s\n", eth.getIPAddress());
    
    //TCPSocketConnection sock;
    //sock.connect("blahblahmbed.comlu.com", 80); //http://blahblahmbed.comlu.com/  "mbed.org"
    
    //char http_cmd[] = "GET http://blahblahmbed.comlu.com/index.php HTTP/1.0\n\n"; // /media/uploads/mbed_official/hello.txt
    //sock.send_all(http_cmd, sizeof(http_cmd)-1);
    while(1) {
        if(DataRX==1) {
            ReadWebData();
            esp.attach(&Rx_interrupt, Serial::RxIrq);
        }
        if(update==1) // update time, hit count, and analog levels in the HUZZAH chip
        {
            // get new values
            gettime();
            //gettemp();
            //getbattery();
            getTemperature();
            //if (tempC > 27) {
//                Alarm = 0.5;
//            }
            count++;
            // send new values
            //sprintf(cmdbuff, "count,time,analog1,analog2=%d,\"%s\",\"%s\",\"%s\"\r\n",count,timebuf,Temp,Vcc);
            sprintf(cmdbuff, "count,time,tempC=%d,\"%s\",\"%f\"\r\n",count,timebuf,tempC);
            //esp1.send(cmdbuff, 1024);
            //esp1.recv(replybuff, sizeof(replybuff));
            SendCMD();
            getreply();
            update=0;   
        }
    }
}

void Email() {
    /////////Emailing the user
    ESP8266Interface esp1(p28, p27, p26, 9600, 3000);
    esp1.init();
    esp1.connect("ssid", "password");
    printf("IP Address is %s\n", esp1.getIPAddress());
    TCPSocketConnection sock;
    //delete esp1;


    sock.connect("blahblahmbed.comlu.com", 80); //http://blahblahmbed.comlu.com/ "mbed.org"

    char http_cmd[] = "GET http://blahblahmbed.comlu.com/index.php HTTP/1.0\n\n"; // /media/uploads/mbed_official/hello.txt
    sock.send_all(http_cmd, sizeof(http_cmd)-1);
    char buffer[300];
    int ret;
    while (true) {
        ret = sock.receive(buffer, sizeof(buffer)-1);
        if (ret <= 0) break;
        buffer[ret] = '\0';
        printf("Received %d chars from server:\n%s\n", ret, buffer);
    }
    sock.close();
    esp1.disconnect();
    //////////
}

// Reads and processes GET and POST web data
void ReadWebData()
{
    wait_ms(200);
    esp.attach(NULL,Serial::RxIrq);
    DataRX=0;
    memset(webdata, '\0', sizeof(webdata));
    strcpy(webdata, rx_buffer);
    memset(rx_buffer, '\0', sizeof(rx_buffer));
    rx_in = 0;
    rx_out = 0;
    // check web data for form information
    if( strstr(webdata, "check=led1v") != NULL ) {
        led1=!led1;
    }
    if( strstr(webdata, "check=led2v") != NULL ) {
        led2=!led2;
    }
    if( strstr(webdata, "check=led3v") != NULL ) {
        led3=!led3;
    }
    if( strstr(webdata, "check=led4v") != NULL ) {
        led4=!led4;
    }
    if( strstr(webdata, "check=speakeron") != NULL ) {
        if (Alarm == 0.5){Alarm=0.0;}
        else Alarm=0.5;
    }
    if( strstr(webdata, "check=photo") != NULL ) {
        alarmPhoto(count);
        FILE *fp = fopen("/local/pict003.jpg", "w");  // Open "out.txt" on the local file system for writing
        if (fp != NULL) {
            pc.printf("File opens\n");
        }
        fclose(fp);
    }
    if( strstr(webdata, "POST") != NULL ) { // set update flag if POST request
        update=1;
    }
    if( strstr(webdata, "GET") != NULL && strstr(webdata, "favicon") == NULL ) { // set update flag for GET request but do not want to update for favicon requests
        update=1;
    }
}
// Starts webserver
void startserver()
{
    gettime();
    //gettemp();
    //getbattery();
    pc.printf("++++++++++ Resetting ESP ++++++++++\r\n");
    strcpy(cmdbuff,"node.restart()\r\n");
    SendCMD();
    wait(2);
    getreply();
    
    pc.printf("\n++++++++++ Starting Server ++++++++++\r\n> ");

    // initial values
    sprintf(cmdbuff, "count,time,analog1,analog2=0,\"%s\",\"%s\",\"%s\"\r\n",timebuf,Temp,Vcc);
    SendCMD();
    getreply();
    wait(0.5);

    //create server
    sprintf(cmdbuff, "srv=net.createServer(net.TCP,%d)\r\n",SERVtimeout);
    SendCMD();
    getreply();
    wait(0.5);
    strcpy(cmdbuff,"srv:listen(80,function(conn)\r\n");
    SendCMD();
    getreply();
    wait(0.3);
        strcpy(cmdbuff,"conn:on(\"receive\",function(conn,payload) \r\n");
        SendCMD();
        getreply();
        wait(0.3);
        
        //print data to mbed
        strcpy(cmdbuff,"print(payload)\r\n");
        SendCMD();
        getreply();
        wait(0.2);
       
        strcpy(cmdbuff,"conn:send('<!DOCTYPE html><html><body><h1>IoT Alarm System</h1>')\r\n");
        SendCMD();
        getreply();
        wait(0.4);
//        strcpy(cmdbuff,"conn:send('<body style=\"background-color:#FF0000;>')\r\n");
//        SendCMD();
//        getreply();
//        wait(0.4);
        strcpy(cmdbuff,"conn:send('Hit count: '..count..'')\r\n");
        SendCMD();
        getreply();
        wait(0.2);
        strcpy(cmdbuff,"conn:send('<br>Last hit (based on mbed RTC time): '..time..'<br><hr>')\r\n");
        SendCMD();
        getreply();
        wait(0.4);
        //strcpy(cmdbuff,"conn:send('Analog 1: '..analog1..' V<br>Analog 2: '..analog2..' V<br><hr>')\r\n");
//        SendCMD();
//        getreply();
//        wait(0.3);
        strcpy(cmdbuff,"conn:send('Temperature: '..tempC..'')\r\n");
        SendCMD();
        getreply();
        wait(0.3);

        strcpy(cmdbuff,"conn:send('<form method=\"POST\"')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        strcpy(cmdbuff, "conn:send('<p><input type=\"checkbox\" name=\"check\" value=\"led1v\"> flip LED1')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        /////////////////////////////////////////////////////////////////////////////////////////////////////////
//        strcpy(cmdbuff, "conn:send('<p><input type=\"image\" src=\"/PICT002.jpg\" alt=\"Submit\"> blah')\r\n");
//        SendCMD();
//        getreply();
//        wait(0.3);
        /////////////////////////////////////////////////////////////////////////////////////////////////////////
        
        strcpy(cmdbuff, "conn:send('<p><input type=\"checkbox\" name=\"check\" value=\"led2v\"> flip LED2')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        strcpy(cmdbuff, "conn:send('<p><input type=\"checkbox\" name=\"check\" value=\"led3v\"> flip LED3')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        strcpy(cmdbuff, "conn:send('<p><input type=\"checkbox\" name=\"check\" value=\"led4v\"> flip LED4')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        
        strcpy(cmdbuff, "conn:send('<p><input type=\"checkbox\" name=\"check\" value=\"speakeron\"> Alarm')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        strcpy(cmdbuff, "conn:send('<p><input type=\"checkbox\" name=\"check\" value=\"photo\"> Take Photo')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        
        strcpy(cmdbuff,"conn:send('<p><input type=\"submit\" value=\"send-refresh\"></form>')\r\n");
        SendCMD();
        getreply();
        wait(0.3);
        strcpy(cmdbuff, "conn:send('<p><h2>How to use:</h2><ul><li>Select a checkbox to flip on/off</li><li>Click Send-Refresh to send data and refresh values</li></ul></body></html>')\r\n");
        SendCMD();
        getreply();
        wait(0.5); 
        // end web page data
        strcpy(cmdbuff, "conn:on(\"sent\",function(conn) conn:close() end)\r\n"); // close current connection
        SendCMD();
        getreply();
        wait(0.3);
        strcpy(cmdbuff, "end)\r\n");
        SendCMD();
        getreply();
        wait(0.2);
    strcpy(cmdbuff, "end)\r\n");
    SendCMD();
    getreply();
    wait(0.2);

    strcpy(cmdbuff, "tmr.alarm(0, 1000, 1, function()\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff, "if wifi.sta.getip() == nil then\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff, "print(\"Connecting to AP...\\n\")\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff, "else\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff, "ip, nm, gw=wifi.sta.getip()\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff,"print(\"IP Address: \",ip)\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff,"tmr.stop(0)\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff,"end\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    strcpy(cmdbuff,"end)\r\n");
    SendCMD();
    getreply();
    wait(0.2);
    
    pc.printf("\n\n++++++++++ Ready ++++++++++\r\n\n");
}


// ESP Command data send
void SendCMD()
{
    int i;
    char temp_char;
    bool empty;
    i = 0;
// Start Critical Section - don't interrupt while changing global buffer variables
    NVIC_DisableIRQ(UART1_IRQn);
    empty = (tx_in == tx_out);
    while ((i==0) || (cmdbuff[i-1] != '\n')) {
// Wait if buffer full
        if (((tx_in + 1) % buffer_size) == tx_out) {
// End Critical Section - need to let interrupt routine empty buffer by sending
            NVIC_EnableIRQ(UART1_IRQn);
            while (((tx_in + 1) % buffer_size) == tx_out) {
            }
// Start Critical Section - don't interrupt while changing global buffer variables
            NVIC_DisableIRQ(UART1_IRQn);
        }
        tx_buffer[tx_in] = cmdbuff[i];
        i++;
        tx_in = (tx_in + 1) % buffer_size;
    }
    if (esp.writeable() && (empty)) {
        temp_char = tx_buffer[tx_out];
        tx_out = (tx_out + 1) % buffer_size;
// Send first character to start tx interrupts, if stopped
        esp.putc(temp_char);
    }
// End Critical Section
    NVIC_EnableIRQ(UART1_IRQn);
    return;
}

// Get Command and ESP status replies
void getreply()
{
    read_line();
    sscanf(rx_line,replybuff);
}
 
// Read a line from the large rx buffer from rx interrupt routine
void read_line() {
    int i;
    i = 0;
// Start Critical Section - don't interrupt while changing global buffer variables
    NVIC_DisableIRQ(UART1_IRQn);
// Loop reading rx buffer characters until end of line character
    while ((i==0) || (rx_line[i-1] != '\r')) {
// Wait if buffer empty
        if (rx_in == rx_out) {
// End Critical Section - need to allow rx interrupt to get new characters for buffer
            NVIC_EnableIRQ(UART1_IRQn);
            while (rx_in == rx_out) {
            }
// Start Critical Section - don't interrupt while changing global buffer variables
            NVIC_DisableIRQ(UART1_IRQn);
        }
        rx_line[i] = rx_buffer[rx_out];
        i++;
        rx_out = (rx_out + 1) % buffer_size;
    }
// End Critical Section
    NVIC_EnableIRQ(UART1_IRQn);
    rx_line[i-1] = 0;
    return;
}
 
 
// Interupt Routine to read in data from serial port
void Rx_interrupt() {
    DataRX=1;
    //led3=1;
// Loop just in case more than one character is in UART's receive FIFO buffer
// Stop if buffer full
    while ((esp.readable()) && (((rx_in + 1) % buffer_size) != rx_out)) {
        rx_buffer[rx_in] = esp.getc();
// Uncomment to Echo to USB serial to watch data flow
        pc.putc(rx_buffer[rx_in]);
        rx_in = (rx_in + 1) % buffer_size;
    }
    //led3=0;
    return;
}
 
 
// Interupt Routine to write out data to serial port
void Tx_interrupt() {
    //led2=1;
// Loop to fill more than one character in UART's transmit FIFO buffer
// Stop if buffer empty
    while ((esp.writeable()) && (tx_in != tx_out)) {
        esp.putc(tx_buffer[tx_out]);
        tx_out = (tx_out + 1) % buffer_size;
    }
    //led2=0;
    return;
}

void gettime()
{
    time_t seconds = time(NULL);
    strftime(timebuf,50,"%H:%M:%S %a %d %b %y", localtime(&seconds));
}

void setRTC()
{
    t.tm_sec = (0);             // 0-59
    t.tm_min = (minute);        // 0-59
    t.tm_hour = (hour);         // 0-23
    t.tm_mday = (dayofmonth);   // 1-31
    t.tm_mon = (month-1);       // 0-11  "0" = Jan, -1 added for Mbed RCT clock format
    t.tm_year = ((year)+100);   // year since 1900,  current DCF year + 100 + 1900 = correct year
    set_time(mktime(&t));       // set RTC clock
}

// Analog in example
void getTemperature()
{
    tempC=myTMP36;
    //Ht = (AdcIn*3.3); // set the numeric to the exact MCU analog reference voltage for greater accuracy
    //tempC = 5.0;
    
    if (tempC > 30.0) {
        //then alarm goes off (speaker)
        //Message sent to webpage (maybe email or text)
        
        //Take input from webpage to turn it off    
    }
    
    //sprintf(Vcc,"%2.3f",tempC);
}
void alarmPhoto(int i)
{
    if (camera.isReady()) {
    char filename[32];
    sprintf(filename, "/local/pict%03d.jpg", i);
    //string a = string(filename);
    pc.printf("Picture: %s ", filename);
        if (camera.takePicture(filename)) 
        {
            while (camera.isProcessing()) 
            {
                camera.processPicture();
            }
        led1 = 1; //show successful picture was taken 
        wait(2.0);
        led1 = 0;
        } 
        else 
         {
             pc.printf("take picture failed\n");
             led3 = 1; //show picture take failed
             wait(2.0);
             led3 = 0;
         }
        } 
    else
         {
            pc.printf("camera is not ready\n");
            led4 = 1; //show camera is not ready
            wait(2.0);
            led4 = 0;
          }  
     led2 = 1; //show end of sequence
     wait(2.0);
     led2 = 0;
     pc.printf("Photo taken\n");
     //return filename;
}



// Analog in example
//void getbattery()
//{
//    AdcIn=Ain1.read();
//    Ht = (AdcIn*3.3); // set the numeric to the exact MCU analog reference voltage for greater accuracy
//    sprintf(Vcc,"%2.3f",Ht);
//}
//// Temperature example
//void gettemp()
//{
// 
//    AdcIn=Ain2.read();
//    Ht = (AdcIn*3.3); // set the numeric to the exact MCU analog reference voltage for greater accuracy  
//    sprintf(Temp,"%2.3f",Ht);
//}